﻿////////////////////////////////////////////////////////////////////////////////////////////////////
//// Copyright(c) HNS Co., Ltd. All rights reserved
//// HNS Site 주소 : https://www.hnsts.co.kr
//// SmartX New Framework Reference Guide : https://www.smartx.co.kr
/////////////////////////////////////////////////// [저작권] ///////////////////////////////////////
//// 본 자료(소스 및 이미지)의 저작권은 ㈜에이치앤에스에 있습니다. 
//// 본 자료는 개발하시는데 참고자료 용도로 사용하실 수 있으며 저작권 표시 없이 복사,게재, 
//// 출판 하실 수 없습니다. 외부 게재 사용 시 반드시 출처 항목에 회사명과 사이트 주소를 
//// 반드시 명시해 주시기 바랍니다.
//// [표기 예] 출처 : ㈜에이치앤에스(www.hnsts.co.kr) 또는 ㈜HNS(www.hnsts.co.kr)
//// 단, 프로그램을 개발할 때는 참고용으로 사용하셔도 됩니다.
//////////////////////////////////////////// [수정 및 업데이트] ////////////////////////////////////
//// [중요] 소스코드는 참고 및 학습용으로 버그 및 여러가지 문제가 있을 수 있습니다.
//// 제품 개발 시 내용과 예제 코드는 수정 및 검증작업을 직접 하셔야 하며 문제 발생에 
//// 대한 책임은 ㈜HNS사와 무관합니다.
//// 본사는 자료를 최신내용으로 유지하기 위해 노력하고 있으며 제공되는 정보의 오류 및 
//// 개선이 필요할 경우 사전 공지 없이 업데이트 될 수 있습니다. 
//// 본 자료(소스 및 이미지)의 문제점 발견 시 본사로 문의주시면 검토하여 자료를 수정하도록 
//// 하겠습니다.
//// 최신 수정일 : 2023.12.15
////////////////////////////////////////////////// [문의방법] //////////////////////////////////////
//// 1. 전화 : 02-6402-8001 (H/W : 2번, S/W : 3번)
//// 2. E-Mail : app@smartx.co.kr
//// 3. QnA : https://www.hnsts.co.kr/Community/QnA
/////////////////////////////////////////////// [프로그램 설명] ////////////////////////////////////
//// 프로그램 이름 : CNetworkDeviceManagement Class_SmartTCPMultiServer
//// 프로그램 설명 : CNetworkDeviceManagement Class를 SmartTCPMultiServer에 적용하여 유무선 네트워크 
//// 연결 지연에 따른 처리 및 유선 네트워크 사용시 MAC Address 설정 기능을 사용할 수 있는  TCP통신의
//// Server 측 예제 프로그램입니다.

//// 사용된 SmartX Framework Version : 5.0.0.10
////////////////////////////////////////////////////////////////////////////////////////////////////

// 본 예제에서는 #define 지시문과 상수를 사용하여 CNetworkDeviceManagement Class 주요 코드 사용법을 설명하고 있습니다.
//#define 지시문 사용(활성화)에 따른 변경 사항을 확인 하여 적용하시길 바랍니다.

//활성화 : 고정 IP 사용 / 비활성화 : 동적 IP 사용
//#define IP_STATIC
// 활성화 : 무선랜 사용 / 비활성화 : 유선랜 사용
#define WIRELESS_LAN

using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace TechNote80_Server_CS
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

#if IP_STATIC
        // 고정(Static) IP를 사용
        // IP 할당 방식 설정
        private const int I_DHCP = 0;
        // IP 할당 방식이 고정(Static)인 경우 할당 받을 IP Address 설정
        private const string DEVICE_IP = "192.168.0.9";
        // IP 할당 방식이 고정(Static)인 경우 할당 받을 GateWay 주소 설정
        private const string GATEWAY = "192.168.0.1";
        // IP 할당 방식이 고정(Static)인 경우 네트워크 장비의 SubNetMask 주소 설정
        private const string SUBNETMASK = "255.255.255.0";
        // IP 할당 방식에 대한 정보 설정
        private const string NETWORK_LABEL_INFO1 = "고정 IP";
#else
        // 동적 (DHCP) IP를 사용
        // IP 할당 방식 설정
        private const int I_DHCP = 1;
        // IP 할당 방식에 대한 정보 설정
        private const string NETWORK_LABEL_INFO1 = "동적 IP";
#endif

        // IP 할당을 시도할 최대 횟수 설정     
        private const int IP_ALLOCATION_RETRY_MAX = 20;

#if WIRELESS_LAN
        // 무선랜을 사용하여 AP에 연결 하는 경우
        // AP에 할당된 IP Address 설정
        private const string SETAPINFOS_AP_ADDRESS = "192.168.0.1";
        // AP Name 설정
        private const string SETAPINFOS_AP_NAME = "iptimeA604R";
        // AP 네트워크 키 설정
        private const string SETAPINFOS_AP_PASSWORD = "";        
        // 무선의 경우 MAC Address 설정을 무시함 하기 위해 빈문자열 처리 (리턴값 true)
        private const string strMACAddressPathName = "";
        // 무선랜 사용에 대한 정보 설정
        private const string NETWORK_LABEL_INFO2 = "무선랜";
        // IPAllocationRetryMax로 설정한 횟수 이상 실패시 출력될 메세지 설정
        private const string IP_FAILED_MESSAGE = "1. 무선 랜 카드 연결 상태 및 네트워크 장비 연결을 확인하시기 바랍니다.\n\n2. 네트워크 장비 전원 및 상태를 확인하시기 바랍니다.";
#else
        // 유선랜의 경우 MAC Address 설정을 위한 txt 파일 경로 상수 설정
        private const string strMACAddressPathName = "Flash Disk\\Run\\MacAddress.txt";
        // 유선랜 사용에 대한 정보 설정
        private const string NETWORK_LABEL_INFO2 = "유선랜";         
         // IPAllocationRetryMax로 설정한 횟수 이상 실패시 출력될 메세지 설정
         private const string IP_FAILED_MESSAGE = "1. 유선 랜 케이블 및 네트워크 장비 연결을 확인하시기 바랍니다.\n\n2. 네트워크 장비 전원 및 상태를 확인하시기 바랍니다.";

#endif
        // IP 할당 및 Server 시작 여부에 따른 Enum
         private enum NetworkConnect
         {
             IPAllocating,
             IPAllocatingFail,
             IPAllocated,
             ServerStart,
             ServerStop,
         }

        // Port 번호 설정
        private const int PORT = 3377;
        // 최대 연결 Client 개수 설정
        private const int MAX_CLIENT = 100;
        // 한 번에 수신 가능한 데이터의 최대 크기 설정
        private const int MAX_RECEIVE_BUFFER_SIZE = 1024;
        // 수신 대기 시간을 설정
        private const int RECIVETIMEOUT = 2000;
        // 최대 연결 Client 개수가 넘었을 때 Client가 연결 시도를 할 경우 보낼 메세지를 설정
        private const string SET_MAX_CONNECTION_RETURN_MSG = "Over Connection";

        // 현재 IP 할당 및 Server 시작 여부를 저장하는 변수
        private NetworkConnect m_NetConnectType;
        // LED 상태를 변경 시켜 주기 위한 변수
        private bool m_bColorTogle = true;
        // 송신한 데이터를 저장할 변수
        private string m_strSendDatas;
        // 송신을 시도한 횟수를 저장할 변수
        private int m_iSendCount = 0;

        // IP 할당 및 Server 시작 기능을 사용하기 위한 Class 생성
        private CNetworkDeviceManagement networkDeviceManagement = new CNetworkDeviceManagement();
                
        private void Form1_Load(object sender, EventArgs e)
        {
            smartForm1.MainForm = this;

            #region 3-2. Server 및 Client 관련 정보 설정

            // Server 관련 정보 설정
            // 데이터 수신 처리 방식을 동기 방식으로 설정
            smartTCPMultiServer1.SendCallBackType = SmartX.SmartTCPMultiServer.CALLBACKTYPE.Sync;
            smartTCPMultiServer1.MaxClient = MAX_CLIENT;
            smartTCPMultiServer1.MaxReceiveBufferSize = MAX_RECEIVE_BUFFER_SIZE;
            smartTCPMultiServer1.Port = PORT;
            smartTCPMultiServer1.ReceiveTimeout = RECIVETIMEOUT;

            // networkDeviceManagement 값 설정
            networkDeviceManagement.pSmartConfig = smartConfigs1;
            networkDeviceManagement.FailedMessage = IP_FAILED_MESSAGE;
            networkDeviceManagement.IPAllocationRetryMax = IP_ALLOCATION_RETRY_MAX;

            #endregion

            #region 3-X. 유/무선 랜 환경에서 사용하기

#if WIRELESS_LAN
            // 무선랜 타입 설정 (RT2870 - 신형 / RT2501 - 구형)
            networkDeviceManagement.NetworkDeviceType = CNetworkDeviceManagement.NetDeviceType.WirelessLAN_RT2870;
            // AP에 할당된 IP Address, AP Name, AP Password
            networkDeviceManagement.SetAPInfos(SETAPINFOS_AP_ADDRESS, SETAPINFOS_AP_NAME, SETAPINFOS_AP_PASSWORD);
#else
            // 유선랜 타입 설정
            networkDeviceManagement.NetworkDeviceType = CNetworkDeviceManagement.NetDeviceType.WiredLAN;
            // 유선랜 연결 전 제품별 MAC Address 설정에 필요한 MAC Address 파일 경로 설정 
            networkDeviceManagement.MACAddressFilePathName = strMACAddressPathName;

            // 유선랜 연결 전 제품별 MAC Address 비교 및 설정 
            if (networkDeviceManagement.MacAddress_Setting() == false)
            {
                // MAC Address 주소가 설정되지 않을 경우 처리
                labMACAddress.Text = "설정 실패";
            }
            else
            {
                // MAC Address 값을 저장하기 위한 변수
                string strMACAddress;
                byte[] byteMACAddress;

                // 현재 IEC-Series에 설정된 MAC Address 읽어와 배열로 저장
                byteMACAddress = smartConfigs1.IPSettings.GetMACAddress();
                // 배열로 가져온 MAC Address 를 문자열의 MAC Address의 형식으로 저장
                strMACAddress = string.Format("{0:X2}:{1:X2}:{2:X2}:{3:X2}:{4:X2}:{5:X2}", byteMACAddress[0], byteMACAddress[1], byteMACAddress[2], byteMACAddress[3], byteMACAddress[4], byteMACAddress[5]);
                // 현재 MAC Address를 출력
                labMACAddress.Text = strMACAddress;
            }
#endif
            // IP 할당 관련 설정을 위한 IPSetInfos 생성
            CNetworkDeviceManagement.NetIPSetInfos IPSetInfos = new CNetworkDeviceManagement.NetIPSetInfos();
#if IP_STATIC
            // 고정(Static) IP 사용
            IPSetInfos.iDHCP = I_DHCP;
            IPSetInfos.DeviceIP = DEVICE_IP;
            IPSetInfos.GateWay = GATEWAY;
            IPSetInfos.SubNetMask = SUBNETMASK;
# else
            // 동적(DHCP) IP 사용
            IPSetInfos.iDHCP = I_DHCP;            
#endif
            // IP 할당 관련 설정값을 전달
            networkDeviceManagement.SetIPSettings(IPSetInfos);

            #endregion

            #region 3-5. 이벤트 등록 및 연결 감시

            // IP 할당 성공, 실패 이벤트 등록
            networkDeviceManagement.On_Failed += new CNetworkDeviceManagement.FailHandler(NetworkDeviceManagement_On_Failed);
            networkDeviceManagement.On_Completion += new CNetworkDeviceManagement.CompletionHandler(NetworkDeviceManagement_On_Completion);

            // IP 할당 여부 확인 시작
            networkDeviceManagement.Start();

            #endregion

            // 현재 IP 할당 및 Server 시작 여부를 표시하기 위한 LED 이미지 객체 추가
            picStateImg.AddImageList(Properties.Resources.Yellow);
            picStateImg.AddImageList(Properties.Resources.Blue);
            picStateImg.AddImageList(Properties.Resources.Green);
            picStateImg.AddImageList(Properties.Resources.Orange); 
            picStateImg.AddImageList(Properties.Resources.Red);
            picStateImg.AddImageList(Properties.Resources.None);

            // IP 할당 시도 Log 메세지 출력을 위한 Timer Interval 설정
            LogMsgTimer.Interval = 100;
            // IP 할당 시도 횟수를 Log 메세지로 출력 시작
            LogMsgTimer.Start();

            // #define 지시문 사용에 의해 할당된 IP 관련 정보를 출력
            labNetworkInfo.Text = NETWORK_LABEL_INFO1 + "-" + NETWORK_LABEL_INFO2;
            // IP 할당 진행 중 상태 출력
            labServerStatus.Text = "IP Allocating";

            // 현재 연결 상태를 IP 할당 진행중으로 변경  
            m_NetConnectType = NetworkConnect.IPAllocating;
            // IP 할당 및 Server 시작 여부에 따른 LED 상태를 보여주기 위한 Timer Interval 설정
            LEDStateTimer.Interval = 500;
            // IP 할당 및 Server 시작 여부에 따른 LED 상태 출력 시작
            LEDStateTimer.Start();
        }

        // IP 할당에 성공했을 때 발생되는 이벤트
        private void NetworkDeviceManagement_On_Completion(ref bool bServerConnect)
        {            
            // 현재 연결 상태를 IP 할당 성공으로 변경
            m_NetConnectType = NetworkConnect.IPAllocated;

            // IP 할당 진행 횟수 Log 메세지 출력 중지
            LogMsgTimer.Stop();

            // IP 할당 성공에 의한 처리            
            labNetworkStatus.Text = "IP 할당 성공";
            labServerStatus.Text = "IP Allocated";
            lsbLogMsg.AddItem("IP 할당에 성공하였습니다.");

            
            if (NETWORK_LABEL_INFO2 == "무선랜")
            {
                // 무선랜의 경우 IP Address를 확인
                labServerIP.Text = smartConfigs1.USBWirelessIPSettings.DeviceIP.ToString();
            }
            else 
            {
                // 유선랜의 경우 IP Address를 확인
                labServerIP.Text = smartConfigs1.IPSettings.DeviceIP.ToString();
            }

            // 현재 Server가 시작되지 않은 경우 Server 시작
            if (smartTCPMultiServer1.IsStart == false)
            {
                smartTCPMultiServer1.Start();

                bServerConnect = true;
                labServerStatus.Text = "Server Start";
                lsbLogMsg.AddItem("Server가 정상적으로 시작 되었습니다.");

                // 현재 연결 상태를 Server 시작으로 변경
                m_NetConnectType = NetworkConnect.ServerStart;
            }
        }

        // IP 할당 실패 횟수가 설정한 횟수 이상 실패한 경우 발생되는 이벤트
        private void NetworkDeviceManagement_On_Failed(CNetworkDeviceManagement.FailStatus fStatus)
        {            
            if (fStatus == CNetworkDeviceManagement.FailStatus.IP_Allocation_Failed)
            {
                // IP 할당에 실패한 경우
                labNetworkStatus.Text = "IP 할당 실패";
                labServerStatus.Text = "IP Allocating Fail";
                lsbLogMsg.AddItem("IP 할당에 실패하였습니다.");

                // IP 할당에 실패한 경우 진행 횟수 Log 메세지 출력 중지                
                LogMsgTimer.Stop();
                // 현재 연결 상태를 IP 할당 실패로 변경
                m_NetConnectType = NetworkConnect.IPAllocatingFail;
            }
        }

        // IP 할당 시도 횟수를 Log 메세지로 출력해 주기위해 발생되는 이벤트
        private void LogMsgTimer_Tick(object sender, EventArgs e)
        {
            // Log 메세지 리스트를 초기화
            lsbLogMsg.ClearAll();
            // IP 할당 및 Server 연결 재시도 횟수 출력
            IPAllocationRetryMsg();
        }
        
        // IP 할당 및 Server 시작, 중지에 따른 LED 점등, 점멸 상태를 출력해 주기위해 발생되는 이벤트
        private void LEDStateTimer_Tick(object sender, EventArgs e)
        {
            // IP 할당 및 Server 시작 여부에 따른 LED 이미지 출력
            ConnectStateShowLED();
        }

        // Client 연결 및 연결 해제 시 발생하는 이벤트
        private void smartTCPMultiServer1_OnClientUpdate()
        {            
            if (smartTCPMultiServer1.IsStart == true)
            {
                // 연결 Client의 리스트 초기화
                lsbClientList.ClearAll();

                if (smartTCPMultiServer1.ClientInfoList != null)
                {
                    // 배열로 저장된 ID와 IPAddress를 배열의 크기만큼 반복
                    for (int i = 0; i < smartTCPMultiServer1.ClientInfoList.Length; i++)
                    {
                        // 리스트에 Client들을 추가
                        lsbClientList.AddItem(smartTCPMultiServer1.ClientInfoList[i].strID + ", " + smartTCPMultiServer1.ClientInfoList[i].strIPAddress);
                    }
                }
            }
        }

        // Client로 부터 데이터가 수신되었을 때 발생하는 이벤트
        private void smartTCPMultiServer1_OnReceiveHandler(SmartX.SmartTCPMultiServer.CHandleClient.READINFO datas)
        {
            // 문자열로 변환한 수신 데이터를 저장할 변수
            string strRecvData = null;            

            // ASCII 형태의 수신 데이터를 문자열 데이터로 변환
            strRecvData = SmartX.SmartTCPMultiServer.ConvertAsciiByteToString(datas.receiveDatas);

            // 데이터 송신 함수를 통해 선택한 Client로 응답데이터를 전송
            SendToClient(datas.strIPAddress, datas.strID, strRecvData);

            string strData = "ID : " + datas.strID + ", IP : " + datas.strIPAddress + ", ReceiveData : " + strRecvData;

            lsbReciveMsg.AddItem(strData);
            labMsgCnt.Text = lsbReciveMsg.ItemCount.ToString();
            lsbLogMsg.AddItem("데이터를 성공적으로 수신 하였습니다!!");
        } 

        // 인자로 받은 문자열 데이터를 선택한 Client에게 송신하는 함수
        private void SendToClient(string strClientIP, string strClientID, string strSendData)
        {
            m_strSendDatas = m_iSendCount.ToString() + ". " + strSendData;

            // 선택된 ID로 ASCII형식의 데이터를 전송
            smartTCPMultiServer1.SendStringASCIIIP(strClientIP, m_strSendDatas);
        }

        // IP 할당 재시도 횟수를 출력하기 위한 함수
        private void IPAllocationRetryMsg()
        {
            if (networkDeviceManagement.GetIPAllocationRetryCnt > 0)
            {
                string strIPRetryCnt = networkDeviceManagement.GetIPAllocationRetryCnt.ToString();
                string strIPRetryMsg = "IP 할당 재시도 횟수....." + " [ " + strIPRetryCnt + " / " + IP_ALLOCATION_RETRY_MAX.ToString() + " ]";
                lsbLogMsg.AddItem(strIPRetryMsg);
            }
        }

        // IP 할당 및 Server 연결 시도 상태와 결과에 따른 LED 점등 및 점멸 상태를 출력해 주기 위한 함수
        private void ConnectStateShowLED()
        {
            int iOnLedIndex = 5;
            int iOFFLedIndex = 5;

            switch (m_NetConnectType)
            {
                // IP 할당 진행중 (노란색 LED 점멸)
                case NetworkConnect.IPAllocating:
                    iOnLedIndex = 0;
                    iOFFLedIndex = 5;
                    break;
                // IP 할당 실패 (빨간색 LED 점등)
                case NetworkConnect.IPAllocatingFail:
                    iOnLedIndex = 4;
                    iOFFLedIndex = 4;
                    break;
                // IP 할당 성공 (파란색 LED 점등)
                case NetworkConnect.IPAllocated:
                    iOnLedIndex = 1;
                    iOFFLedIndex = 1;
                    break;
                // Server 시작 (초록색 LED 점등)
                case NetworkConnect.ServerStart:
                    iOnLedIndex = 2;
                    iOFFLedIndex = 2;
                    break;
                // Server 중지 (주황색 LED 점등)
                case NetworkConnect.ServerStop:
                    iOnLedIndex = 3;
                    iOFFLedIndex = 3;
                    break;
            }

            if (m_bColorTogle == true)
            {
                m_bColorTogle = false;
                picStateImg.DrawNext(iOnLedIndex);
            }
            else
            {
                m_bColorTogle = true;
                picStateImg.DrawNext(iOFFLedIndex);
            }

            //  NetworkConnect이 IP 할당 실패 또는 Server 시작, 중지의 경우
            if (m_NetConnectType != NetworkConnect.IPAllocating && m_NetConnectType != NetworkConnect.IPAllocated)
            {
                // IP 할당 및 Server 시작 여부에 따른 LED 상태 출력 중지
                LEDStateTimer.Stop();
            }
        }

        // [Server Start] 버튼을 클릭했을 때 발생하는 이벤트
        private void btnServerStart_Click(object sender, EventArgs e)
        {
            // 현재 Server가 시작되지 않은 경우 Server 시작
            if (smartTCPMultiServer1.IsStart == false && labNetworkStatus.Text == "IP 할당 성공")
            {
                smartTCPMultiServer1.Start();
                labServerStatus.Text = "Server Start";
                lsbLogMsg.AddItem("Server 정상적으로 시작 되었습니다.");

                // 현재 연결 상태를 Server 시작으로 변경
                m_NetConnectType = NetworkConnect.ServerStart;
                // IP 할당 및 Server 시작 여부에 따른 LED 상태 출력 시작
                ConnectStateShowLED();                
            }
            else
            {
                lsbLogMsg.AddItem("IP 할당 및 Server 시작 상태를 확인하세요!!");
            }
        }

        // [Server Stop] 버튼을 클릭했을 때 발생하는 이벤트
        private void btnServerStop_Click(object sender, EventArgs e)
        {
            // 현재 Server가 시작된 경우 Server 중지
            if (smartTCPMultiServer1.IsStart == true)
            {
                smartTCPMultiServer1.Stop();
                labServerStatus.Text = "Server Stop";
                lsbLogMsg.AddItem("Server 가 중지 되었습니다.");

                // 현재 연결 상태를 Server 중지로 변경
                m_NetConnectType = NetworkConnect.ServerStop;
                // IP 할당 및 Server 시작 여부에 따른 LED 상태 출력 시작
                ConnectStateShowLED();
            }
        }

        // [Clear Client List] 버튼을 클릭했을 때 발생하는 이벤트
        private void btnClearClient_Click(object sender, EventArgs e)
        {
            // Server와 연결된 모든 Client 리스트를 저장할 변수
            string[] m_strClientList = new string[smartTCPMultiServer1.Clients.Length];

            for (int i = 0; i < smartTCPMultiServer1.Clients.Length; i++)
            {
                m_strClientList[i] = smartTCPMultiServer1.Clients[i].IPAddress;
            }

            for (int i = 0; i < m_strClientList.Length; i++)
            {
                // Server와 연결된 모든 Client의 연결을 해제
                smartTCPMultiServer1.CloseClientIP(m_strClientList[i]);
            }
            // 연결 Client의 리스트 초기화
            lsbClientList.ClearAll();
        }

        // [Clear Message List] 버튼을 클릭했을 때 발생하는 이벤트
        private void btnClearMsgList_Click(object sender, EventArgs e)
        {
            // 수신 메세지 리스트를 초기화
            lsbReciveMsg.ClearAll();
            // 수신 받은 메세지 횟수를 출력
            labMsgCnt.Text = lsbReciveMsg.ItemCount.ToString();
        }
    }
}